#!/usr/bin/env python
import os
import sys

# add lib path
playbook_file = os.path.realpath(sys.argv[0])
playbook_path = os.path.split(playbook_file)[0]

lib_path = os.path.join(playbook_path, 'library')
if os.path.exists(lib_path) is True:
    sys.path.insert(0, lib_path)
    lib_path = os.path.join(lib_path, 'securecat')
    if os.path.exists(lib_path) is True:
        sys.path.insert(0, lib_path)
        modulepath = os.environ.get('CSC_MODULE_PATH')
        if modulepath is None:
            os.environ['CSC_MODULE_PATH'] = lib_path

from utils import playbook


class MyPlaybook(playbook.Playbook):
    def set_extra_vars_pre(self):
        self._runcontext.set_extra_var('DOCKER_HOME', '/var/lib/docker')
        self._runcontext.set_extra_var('DOCKER_BIN', '/usr/bin/docker')

    def set_extra_vars_post(self):
        errorMsg = ''

        docker_home = self._runcontext.get_extra_var('CONF_PATH')
        if not os.path.exists(docker_home):
            errorMsg = 'DOCKER_HOME <%s> is not exists.' % docker_home
            raise Exception(errorMsg)

        docker_bin = self._runcontext.get_extra_var('BIN_PATH')
        if not os.path.exists(docker_bin):
            errorMsg = 'DOCKER_BIN <%s> is not exists.' % docker_bin
            raise Exception(errorMsg)

    def get_tasks(self, dir):
        ret = []
        ret.append([dir, 'r_3_2_1_1.py'])
        ret.append([dir, 'r_3_2_1_5.py'])
        ret.append([dir, 'r_3_2_2_1.py'])
        ret.append([dir, 'r_3_2_2_3.py'])
        ret.append([dir, 'r_3_2_2_6.py'])
        ret.append([dir, 'r_3_2_2_7.py'])
        ret.append([dir, 'r_3_2_2_8.py'])
        ret.append([dir, 'r_3_2_2_9.py'])
        ret.append([dir, 'r_3_2_2_11.py'])
        ret.append([dir, 'r_3_2_3_7.py'])
        #ret.append([dir, 'r_3_2_3_8.py'])
        ret.append([dir, 'r_3_2_3_9.py'])
        ret.append([dir, 'r_3_2_3_10.py'])
        ret.append([dir, 'r_3_2_5_5.py'])
        ret.append([dir, 'r_3_2_5_6.py'])
        ret.append([dir, 'r_3_2_5_11.py'])
        ret.append([dir, 'r_3_2_5_16.py'])
        ret.append([dir, 'r_3_2_5_17.py'])
        ret.append([dir, 'r_3_2_5_18.py'])
        ret.append([dir, 'r_3_2_5_19.py'])
        ret.append([dir, 'r_3_2_5_20.py'])
        ret.append([dir, 'r_3_2_5_21.py'])
        ret.append([dir, 'r_3_2_5_22.py'])
        ret.append([dir, 'r_3_2_5_23.py'])
        ret.append([dir, 'r_3_2_5_25.py'])
        ret.append([dir, 'r_3_2_5_26.py'])
        return ret


if __name__ == '__main__':
    myplaybook = MyPlaybook()
    myplaybook.set_role('hw')
    myplaybook.run()
